import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.1     // Extras
import QtMultimediaKit 1.1

import "Database.js" as DataBase


Page {
    id: mainPage
    orientationLock: PageOrientation.LockPortrait
    //http://listen.sky.fm/public3

    //Channels
    //http://api.audioaddict.com/v1/di/channels
    //Playback history
    //http://api.audioaddict.com/v1/sky/track_history/channel/22.json
    //Icons:
    //http://api.audioaddict.com/v1/assets/channel_sprite/sky/default/?width=128&height=128

    property variant icons
    property variant favorite
    property variant currentTrackIcon
    property string currentTrackId
    property string currentRadioId: ""
    property string currentStation: "radiotunes"
    property string currentDomen: "com"
    property string currentCheckedButton: "skyfm"

    property double startedTime: 0
    property double trackLen: 0

    property int sleepTime: 0

    function sendHttpRequest(url, callback) {
        var doc = new XMLHttpRequest();
        doc.onreadystatechange = function() {
                    if (doc.readyState == 4) {
//                        console.log("http response", doc.status, "\nText: ", doc.responseText)
                        if (doc.status == 200) {
                            callback(doc.responseText);
                        } else {
                            callback("error");
                            infoBanner.text = qsTr("Error happened during data receiving");
                            infoBanner.show();
                        }
                    } else {
//                        console.log("http response", doc.responseText)
                    }
                }
        doc.open("GET", url);
        console.log("send url", url)
        doc.send();
    }


    function sendPostHttpRequest(url, callback, params) {
        var doc = new XMLHttpRequest();
        doc.onreadystatechange = function() {
                    if (doc.readyState == 4) {
//                        console.log("http response", doc.status, "\nText: ", doc.responseText)
                        if (doc.status == 200) {
                            callback(doc.responseText);
                        } else {
                            callback("error");
                            infoBanner.text = qsTr("Error happened during data receiving");
                            infoBanner.show();
                        }
                    } else {
//                        console.log("http response", doc.responseText)
                    }
                }
        doc.open("POST", url);
        doc.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
        console.log("send url", url)
        doc.send(params);
    }

    function getTrackLen(duration) {
        //((json[i].duration  - (Math.floor(json[i].duration / 60) * 60))<10)?json[i].duration  - (Math.floor(json[i].duration / 60) * 60):"0" + json[i].duration  - (Math.floor(json[i].duration / 60) * 60)
        if((duration  - (Math.floor(duration / 60) * 60))<10) {
            return "0" + (duration  - (Math.floor(duration / 60) * 60))
        } else {
            return duration - Math.floor(duration / 60) * 60
        }
    }

    function getStations() {
        playerItem.visible = false;
        playerItem.height = 0;
        playerItem.opacity = 0;
        busyIndicator.running = true;
        busyIndicator.visible = true;
        icons = {};
        favorite = {};
//        var url = "http://listen." + currentStation + "." + currentDomen + "/public3";
        var url = "http://api.audioaddict.com/v1/" + currentStation + "/channels";
        sendHttpRequest(url, parseData);
    }

    function getChannel(data) {
        var json = JSON.parse(data);
        for(var i in json) {
            if(json[i].type !== "advertisement") {
                favorite = json[i];
                currentRadioIcon.opacity = 0;
                if(json[i].art_url) {
                    currentRadioIcon.source = "http:" + json[i].art_url;
                } else {
                    currentRadioIcon.source = currentTrackIcon;
                }
                currentRadioIcon.opacity = 1;
                if(DataBase.isTrackPresent(json[i].track_id)) {
                    favButton.iconId = "toolbar-favorite-mark";
                } else {
                    favButton.iconId = "toolbar-favorite-unmark";
                }

                favButton.visible = true;
                track.text = json[i].track;
                var started = new Date(json[i].started*1000);
                startedTime = started.getTime();
                var finished = new Date((json[i].started+json[i].duration)*1000);
                trackLen = finished.getTime();
//                var sec = ((json[i].duration  - (Math.floor(json[i].duration / 60) * 60))<10)?json[i].duration  - (Math.floor(json[i].duration / 60) * 60):"0" + json[i].duration  - (Math.floor(json[i].duration / 60) * 60);
                showTime.text =  Math.floor(json[i].duration / 60) + ":" + getTrackLen(json[i].duration)
                break;
            }
        }
    }

    function parseData(data) {
//        console.log("parceData", data)
        var json = JSON.parse(data);
        icons = json;
        for(var i in json) {
            stationsList.append(json[i]);
        }
//        var url = "http://api.audioaddict.com/v1/assets/channel_sprite/" + currentStation + "/default/?width=64&height=64"
//        sendHttpRequest(url, getIcons)
        busyIndicator.running = false;
        busyIndicator.visible = false;
    }

    function getSource(data) {
//        var toClass = {}.toString
////        console.log(data)
//        var linkFile = /(?:File\d=)(\S*)/g
//        var linkTitle = /(?:Title\d=)(.*)/g
//        var link = null;
//        var title = null;
//        while(((link = linkFile.exec(data)) !== null) && ((title = linkTitle.exec(data)) !== null)) {
//            radioServers.append({link: link[1], title: title[1]})
//            radioPlayer.source = link[1];
//        }
//        console.log(data)
        var links = JSON.parse(data);
//        for(var i in links) {

//        }
        radioPlayer.source = links[1];
        playerItem.height = mainPage.height * 0.4
        playerItem.visible = true;
        playerItem.opacity = 1;
    }

    function getIcons(data) {
        //.channel-icon-32-
        for(var i in icons) {
            var pattern = "(?:.channel-icon-64-" + icons[i].id + " { background-image: url\\()(.*)(?:\\); })"
            var regexp = new RegExp(pattern, "g");
            var res = null;
            if((res = regexp.exec(data)) !== null) {
                icons[i].icon = res[1]
                var tmp = icons[i]
                tmp.icon = res[1]
                stationsList.append(tmp);
            }
        }
        busyIndicator.running = false;
        busyIndicator.visible = false;
    }

    function getCurrentRadioIcon(data) {
        var pattern = "(?:.channel-icon-128-" + currentRadioId + " { background-image: url\\()(.*)(?:\\); })"
        var regexp = new RegExp(pattern, "g");
        var res = null;
        if((res = regexp.exec(data)) !== null) {
            currentTrackIcon = res[1];
            currentRadioIcon.source = currentTrackIcon;
            currentRadioIcon.opacity = 1;

            //http://api.audioaddict.com/v1/sky/track_history/channel/22.json
            var url = "http://api.audioaddict.com/v1/" + currentStation + "/track_history/channel/" + currentRadioId + ".json";
            sendHttpRequest(url, getChannel);
//            updateTrack.start();
            updateSlider.start();
        }
    }

    function updateProgress() {
        /*
        var currTime = new Date();
        //Math.floor(json[i].duration / 60) + ":" + getTrackLen(json[i].duration)
        if(trackLen >= currTime.getTime()) {
//            console.log("Update value", trackLen, currTime.getTime())
            var trackStart = new Date(startedTime);
            trackTime.maximumValue = trackLen - trackStart.getTime();
            trackTime.value = currTime.getTime() - startedTime;
            zeroValue.text = Math.floor(Math.floor(Math.abs(currTime.getTime() - trackStart.getTime())/1000) / 60) + ":" + getTrackLen(Math.floor(Math.abs(currTime.getTime() - trackStart.getTime())/1000));
        } else {
            console.log("Send history request", trackLen)
            var url = "http://api.audioaddict.com/v1/" + currentStation + "/track_history/channel/" + currentRadioId + ".json";
            sendHttpRequest(url, getChannel);
            zeroValue.text = "0:00"
        }
        */
        var url = "http://api.audioaddict.com/v1/" + currentStation + "/track_history/channel/" + currentRadioId + ".json";
        sendHttpRequest(url, getChannel);
    }


    function updateStatus(data) {
        if(data !== 'error') {
            var userData = JSON.parse(data);
            var lastEl = userData.subscriptions.length - 1;
            if(userData.subscriptions[lastEl].status) {
                DataBase.setSetting("status", userData.subscriptions[lastEl].status)
            }
        }
    }

//    Timer {
//        id: updateTrack
//        interval: 9000
//        repeat: true
//        onTriggered: {
//            var url = "http://api.audioaddict.com/v1/" + currentStation + "/track_history/channel/" + currentRadioId + ".json";
//            sendHttpRequest(url, getChannel);
//        }
//    }

    Timer {
        id: updateSlider
//        interval: 500
        interval: 5000
        repeat: true
        onTriggered: {
            updateProgress();
        }
    }

    Timer {
        id: sleepTimer
//        interval: 500
        interval: 1000
        repeat: true
        onTriggered: {
            if(sleepTime > 0) {
                sleepTime -= 1;
                menuTimer.text = "Time left: " + Math.floor(sleepTime / 60) + ":" + getTrackLen(sleepTime);
            } else {
                sleepTimer.stop();
                radioPlayer.stop();
                menuTimer.text = "Timer"
            }
        }
    }

    InfoBanner {
        id: infoBanner
        text: ""
        timerShowTime: 2000
    }

    BusyIndicator {
        id: busyIndicator
        anchors.centerIn: parent
        running: false
        visible: false
        platformStyle: BusyIndicatorStyle { size: "large" }
    }

    Component.onCompleted: {
        DataBase.initialize();
        var current_theme = DataBase.getSetting('inverted');
        if (current_theme === "Error") {
            DataBase.setSetting('inverted', 'false')
        } else if (current_theme === 'true') {
            // Use the dark theme.
            theme.inverted = true;
            themeCheckBox.checked = true;
        }
        var current_station = DataBase.getSetting('station');
        var current_domen = DataBase.getSetting('domen');
        var current_tab = DataBase.getSetting('checkedButton');
        if (current_station === "Error") {
            DataBase.setSetting('station', 'radiotunes')
            DataBase.setSetting('domen', 'com')
        } else {
            currentStation = current_station;
            currentDomen = current_domen;
//            currentCheckedButton = current_tab;
//            buttonRow.checkedButton = current_tab;
            switch(current_tab) {
            case "skyfm":
                buttonRow.checkedButton = skyfm;
                break;
            case "difm":
                buttonRow.checkedButton = difm;
                break;
            case "jazz":
                buttonRow.checkedButton = jazz;
                break;
            case "rock":
                buttonRow.checkedButton = rock;
                break;
            default:
                buttonRow.checkedButton = skyfm;
                break;
            }
        }

        var api_key = DataBase.getSetting("api_key");
        if(api_key !== 'Error') {
            var url = "https://api.audioaddict.com/v1/di/members/authenticate";
            var post_params = "api_key=" + api_key
            sendPostHttpRequest(url, updateStatus, post_params);
        }

        getStations();
    }

    ListModel {
        id: stationsList
    }

    ListModel {
        id: radioServers
    }

    Component {
        id: stationsDelegate
        Item {
            id: stationsDelegateItem
            height: 120
            width: parent.width
            Image {
                id: radioIcon
                anchors.left: parent.left
                anchors.leftMargin: 15
                anchors.verticalCenter: parent.verticalCenter
                width: 100
                height: 100
                fillMode: Image.PreserveAspectFit
//                source: icon
                source: "http:" + asset_url
            }

            Label {
                id: radioTitle
                anchors.left: radioIcon.right
                anchors.leftMargin: 15
                anchors.top: radioIcon.top
//                anchors.verticalCenter: parent.verticalCenter
                font.bold: true
                text: name
            }
            Text {
                id: radioDescrioption
                width: parent.width
                anchors.top: radioTitle.bottom
                anchors.topMargin: 5
                anchors.left: radioTitle.left
                anchors.right: parent.right
                anchors.rightMargin: 10
                wrapMode: Text.WordWrap
                text: description_short
            }
            Rectangle {
                id: delimeter
                anchors.bottom: parent.bottom
                anchors.horizontalCenter: parent.horizontalCenter
                width: parent.width * 0.98
                height: 3
                radius: 10
                smooth: true
                gradient:  Gradient {
                    GradientStop { position: 0.0; color: "gray" }
                    GradientStop { position: 0.33; color: "white" }
                    GradientStop { position: 1.0; color: "lightgray" }
                }
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
//                    updateTrack.stop();
                    updateSlider.stop();
                    radioPlayer.stop();
                    radioPlayer.source = "";
                    track.text = "";
                    trackDuration.text = "";
                    currentRadioIcon.source = "";
                    currentRadioIcon.opacity = 0;
                    currentRadioId = id;
//                    var url = "http://api.audioaddict.com/v1/assets/channel_sprite/" + currentStation + "/default/?width=128&height=128";
//                    sendHttpRequest(url, getCurrentRadioIcon);
                    currentTrackIcon = "http:" + asset_url;
                    currentRadioIcon.source = currentTrackIcon;
                    currentRadioIcon.opacity = 1;
                    //http://api.audioaddict.com/v1/sky/track_history/channel/22.json
                    var url = "http://api.audioaddict.com/v1/" + currentStation + "/track_history/channel/" + currentRadioId + ".json";
                    sendHttpRequest(url, getChannel);
                    currentRadio.text = name;
                    radioServers.clear();
                    var playlist = "http://listen." + currentStation + "." + currentDomen + "/public3/" + key;
                    var status = DataBase.getSetting("status");
                    if(status !== 'Error' && status !== 'expired') {
                        var listen_key = DataBase.getSetting("listen_key");
                        playlist += "?" + listen_key;
                    }
                    console.log("playlist", playlist)
                    //http://listen.di.fm/public3/trance
                    sendHttpRequest(playlist, getSource);
                    updateSlider.start();
                }
            }
        }
    }

    Component {
        id: radioServersDelegate
        Item {
            id: radioServerItem
            height: serverTitle.height + 5
            width: 100
            Label {
                id: serverTitle
                anchors.centerIn: parent
                text: qsTr("Source ") + (index + 1)
            }
            Rectangle {
                anchors.right: parent.right
                anchors.verticalCenter: parent.verticalCenter
                height: parent.height * 0.95
                width: 1
                color: "gray"
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    radioPlayer.stop();
                    radioPlayer.source = link;
                    radioPlayer.play();
                }
            }
        }
    }

    Component {
        id: highlight
        Rectangle {
            width: parent.width;
            height: 78;
            color: "lightsteelblue";
            radius: 5;
            y: radioList.currentItem.y
            Behavior on y {
                SpringAnimation {
                    spring: 3
                    damping: 0.2
                }
            }
        }
    }
    Component {
            id: highlightComponent

            Rectangle {
                width: ListView.view.width
                color: "lightsteelblue"
            }
        }
    ListView {
        id: radioList
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.bottom: playerItem.top
        anchors.margins: 10
        model: stationsList
        delegate: stationsDelegate
//        highlight: highlightComponent
//        highlightFollowsCurrentItem: false
        clip: true
        spacing: 5
    }

    Item {
        id: playerItem
        anchors.bottom: parent.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        height: 0
        width: parent.width
        visible: false
        opacity: 0

        Behavior on height { NumberAnimation {} }
        Behavior on opacity { NumberAnimation {duration: 1000} }

        Rectangle {
            id: delimeterItem
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
            width: parent.width * 0.99
            height: 3
            radius: 10
            smooth: true
            gradient:  Gradient {
                GradientStop { position: 0.0; color: "gray" }
                GradientStop { position: 0.33; color: "white" }
                GradientStop { position: 1.0; color: "lightgray" }
            }
        }

        Image {
            id: currentRadioIcon
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.margins: 15
            fillMode: Image.PreserveAspectFit
            width: 128
            height: 128
            source: ""
            opacity: 0
            Behavior on opacity {
                NumberAnimation {duration: 3000; easing.type: Easing.InCirc; easing.amplitude: 1000}
            }
        }
        Label {
            id: currentRadio
            anchors.top: currentRadioIcon.top
            anchors.left: currentRadioIcon.right
            anchors.leftMargin: 15
//            anchors.verticalCenter: currentRadioIcon.verticalCenter
            text: ""
        }

        ToolIcon {
            id: playButton
//            anchors.centerIn: parent
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.verticalCenter: currentRadioIcon.verticalCenter
            iconId: radioPlayer.playing?"toolbar-mediacontrol-stop":"toolbar-mediacontrol-play"
            width: 60
            height: 60
            onClicked: {
                if (radioPlayer.playing) {
                    radioPlayer.stop()
                } else {
                    radioPlayer.play()
                }
            }
        }

        Text {
            id: trackDuration
            visible: false
            anchors.bottom: currentRadioIcon.bottom
            anchors.left: currentRadio.left
            text: "" //duration
        }

        Label {
            id: track
            anchors.top: currentRadioIcon.bottom
            anchors.topMargin: 20
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.leftMargin: 10
            anchors.rightMargin: 10
            width: parent.width
            wrapMode: Text.WordWrap
            horizontalAlignment: Text.AlignHCenter
            text: ""
        }

        ToolIcon {
            id: favButton
//            anchors.centerIn: parent
            anchors.right: parent.right
            anchors.rightMargin: 15
            anchors.verticalCenter: currentRadioIcon.verticalCenter
            enabled: true
            visible: false
            iconId: "toolbar-favorite-unmark" //favButton.enabled?"toolbar-favorite-mark":"toolbar-favorite-unmark"
            width: 60
            height: 60
            onClicked: {
                if(favButton.enabled) {
                    favButton.iconId = "toolbar-favorite-mark";
                    DataBase.addToFavorites(favorite.track_id, favorite.artist, favorite.title, currentRadioIcon.source);
                }
            }
        }

        ProgressBar {
            id: trackTime
            visible: false
            anchors.top: track.bottom
            anchors.topMargin: 10
            anchors.horizontalCenter: parent.horizontalCenter
            width: parent.width * 0.95
            indeterminate: false
            minimumValue: 0
            maximumValue: 10
            value: 0
            Behavior on value {
                NumberAnimation {duration: 500}
            }
        }


        Button {
            anchors.bottom: parent.bottom
            anchors.horizontalCenter: parent.horizontalCenter
            visible: false
            text: "Drop fav base"
            onClicked: {
                DataBase.dropTheBase();
            }
        }
        Label {
            id: zeroValue
            visible: false
            anchors.top: trackTime.bottom
            anchors.topMargin: 10
            anchors.left: trackTime.left
            text: "0:00"
        }
        Label {
            id: showTime
            visible: false
            anchors.top: trackTime.bottom
            anchors.topMargin: 10
            anchors.right: trackTime.right
            text: ""
        }

        ListView {
            id: serversView
            visible: false
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 15
            anchors.left: parent.left
            anchors.right: parent.right
            height: 80
            model: radioServers
            delegate: radioServersDelegate
            orientation: ListView.Horizontal
        }
    }
    TimePickerDialog {
        id: timePicker
        titleText: "Timer"
        acceptButtonText: "Set"
        rejectButtonText: "Cancel"
        fields: DateTime.Minutes | DateTime.Seconds
        onAccepted: {
            sleepTime = (timePicker.hour * 3600) + (timePicker.minute * 60) + timePicker.second
            sleepTimer.start();
        }
        onRejected: {
            timePicker.close()
        }
    }

    Audio {
        id: radioPlayer
        source: ""
        autoLoad: false
        onStarted: {
            playButton.iconId = "toolbar-mediacontrol-stop"
        }
        onStopped: {
            playButton.iconId = "toolbar-mediacontrol-play"
        }
    }

    Menu {
        id: myMenu
        MenuLayout {
            MenuItem {
                id: menuTimer
                text: qsTr("Timer")
                enabled: radioPlayer.playing;
                onClicked: {
                    timePicker.open();
                }
            }
            MenuItem {
                text: qsTr("Favorites")
                onClicked: {
//                    updateTrack.stop();
                    pageStack.push(Qt.resolvedUrl("FavoriteList.qml"))
                }
            }
            MenuItem {
                text: qsTr("Inverted theme")
                CheckBox {
                    id: themeCheckBox
                    anchors.right: parent.right
                    anchors.verticalCenter: parent.verticalCenter
                    checked: theme.inverted
                }

                onClicked: {
                    // Use the dark theme.
                    theme.inverted = !theme.inverted;
                    var tmp = theme.inverted;
                    DataBase.setSetting('inverted', tmp.toString());
                }
            }
            MenuItem {
                text: qsTr("Premium")
                onClicked: {
                    pageStack.push(Qt.resolvedUrl("LogIn.qml"), {key:currentStation})
                }
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        ButtonRow {
            id: buttonRow
//            checkedButton: skyfm
//            checkedButton: currentCheckedButton
            TabButton {
                id: skyfm
                text: "sky.fm"
                onClicked: {
                    stationsList.clear()
                    currentStation = "radiotunes"
                    currentDomen = "com"
                    DataBase.setSetting('station', 'radiotunes')
                    DataBase.setSetting('domen', 'com')
                    DataBase.setSetting('checkedButton', 'skyfm')
                    getStations();
                }
            }
            TabButton {
                id: difm
                text: "di.fm"
                onClicked: {
                    stationsList.clear()
                    currentStation = "di"
                    currentDomen = "fm"
                    DataBase.setSetting('station', 'di')
                    DataBase.setSetting('domen', 'fm')
                    DataBase.setSetting('checkedButton', 'difm')
                    getStations();
                }
            }
            TabButton {
                id: jazz
                text: "jazz"
                onClicked: {
                    stationsList.clear()
                    currentStation = "jazzradio"
                    currentDomen = "com"
                    DataBase.setSetting('station', 'jazzradio')
                    DataBase.setSetting('domen', 'com')
                    DataBase.setSetting('checkedButton', 'jazz')
                    getStations();
                }
            }
            TabButton {
                id: rock
                text: "rock"

                onClicked: {
                    stationsList.clear()
                    currentStation = "rockradio"
                    currentDomen = "com"
                    DataBase.setSetting('station', 'rockradio')
                    DataBase.setSetting('domen', 'com')
                    DataBase.setSetting('checkedButton', 'rock')
                    getStations();
                }
            }
        }
        ToolIcon {
            id: menu
            anchors.right: parent.right
            platformIconId: "toolbar-view-menu"
            onClicked: (myMenu.status === DialogStatus.Closed) ? myMenu.open() : myMenu.close()
        }
    }
}
